#include "UbidotsEsp32Mqtt.h"

/****************************************
 * Define Constants
 ****************************************/


const char *WIFI_SSID = "";      // Put your Wi-Fi SSID here
const char *WIFI_PASS = "";      // Put your Wi-Fi password here
const char *UBIDOTS_TOKEN = "";  // Put your Ubidots TOKEN here

const int PUBLISH_FREQUENCY = 2000; // Update rate in milliseconds

const char *DEVICE_LABEL = "Flow_meter";   // Put here your Device label to which data  will be published
const char *FLOW_VARIABLE_LABEL = "Flow_rate"; // Put here your Variable label to which data  will be published
const char *WATER_VARIABLE_LABEL = "Water_flowed"; 
                            

unsigned long timer;
uint8_t analogPin = 34; // Pin used to read data from GPIO34 ADC_CH6.

Ubidots ubidots(UBIDOTS_TOKEN);

/****************************************
 * Auxiliar Functions
 ****************************************/
  
void callback(char *topic, byte *payload, unsigned int length)
{
  Serial.print("Message arrived [");
  Serial.print(topic);
  Serial.print("] ");
  for (int i = 0; i < length; i++)
  {
    Serial.print((char)payload[i]);
  }
  Serial.println();
}

/****************************************
 * Main Functions
 ****************************************/


  
     float flow=0.0;
     float water=0.0;


void setup()
{
  // put your setup code here, to run once:
  Serial.begin(9600);
  // ubidots.setDebug(true);  // uncomment this to make debug messages available
  ubidots.connectToWifi(WIFI_SSID, WIFI_PASS);
  ubidots.setCallback(callback);
  ubidots.setup();
  ubidots.reconnect();

  timer = millis();
}
String rxed="";
String flow_string="";
String water_string="";



void loop()
{



 
  if (!ubidots.connected())
  {
    ubidots.reconnect();
  }
 
 
  if(Serial.available()>0)
  {

rxed = Serial.readStringUntil('\n');
flow_string = rxed.substring(0,5);
water_string = rxed.substring(5,10); // 4*3 = 12 , 5*85= 425,00.00
Serial.print("Flow Rate: ");
Serial.print(flow_string);
Serial.print("\t");
Serial.print("Water Flowed: ");
Serial.println(water_string);



delay(10);





flow = flow_string.toFloat();
water = water_string.toFloat();


if ((millis() - timer) > (unsigned long) PUBLISH_FREQUENCY) // triggers the routine every 5 seconds
  {
   ubidots.add(FLOW_VARIABLE_LABEL, flow); // Insert your variable Labels and the value to be sent
    ubidots.publish(DEVICE_LABEL);
    timer = millis();
    delay(100);

     ubidots.add(WATER_VARIABLE_LABEL, water); // Insert your variable Labels and the value to be sent
    ubidots.publish(DEVICE_LABEL);
    timer = millis();
    delay(100);

   
ubidots.loop();

  }

  

  

delay(10);

Serial.flush();
delay(10);





  }

  
}
