#include "Water_Meter.h"


extern float mL_per_count;
uint32_t flowStartTick = 0;
float flow_rate=0;

float inst_water_flowed ;
uint32_t prev_water_flowed ;
uint32_t total_water_flowed ;
uint8_t ReadErr=0;
uint8_t WriteErr=0;



float flow = 0;
//uint8_t write_buffer[4]={0,0,0,0};
uint8_t read_buffer[4 ]={0,0,0,0};

uint32_t pulse_count = 0;
uint32_t cumulative_count = 0;
uint32_t val=0;
uint32_t memory_reset_flag=0;
uint8_t transmit_flag=0;

uint8_t flow_state = WAIT;
#define WAITING_FOR_FLOW 	(flow_state == WAIT)
#define FLOW_STARTED		(flow_state == START)
#define FLOW_COMPLETED		(flow_state == COMPLETE)





void Check_flow_status()
{
	if(WAITING_FOR_FLOW)
	{
		if(flow_rate > 0)
		{
			flow_state = START;
		}
	}

	if(FLOW_STARTED)
	{
		if(flow_rate == 0)
		{
			flow_state = COMPLETE;
		}
	}
}


void Increment_water_reading()
{
	if(FLOW_COMPLETED)
	{
//		uint32_t data = 0x00;
//		HAL_I2C_Mem_Write(&hi2c1, FRAM_ADDRESS , FLOW_ADDRESS, I2C_MEMADD_SIZE_16BIT,(uint8_t *)  &data, sizeof(data), 100);
//		prev_water_flowed =  Read_from_FRAM();
		HAL_I2C_Mem_Read(&hi2c1, FRAM_ADDRESS , FLOW_ADDRESS, I2C_MEMADD_SIZE_16BIT,(uint8_t *) &prev_water_flowed , sizeof(prev_water_flowed ), 100);
		total_water_flowed = prev_water_flowed  + (uint32_t)(inst_water_flowed*100); /* in 10 mL */
//		Write_to_FRAM(total_water_flowed);
		HAL_I2C_Mem_Write(&hi2c1, FRAM_ADDRESS , FLOW_ADDRESS, I2C_MEMADD_SIZE_16BIT,(uint8_t *)  &total_water_flowed, sizeof(total_water_flowed), 100);
		cumulative_count = 0;
		flow_state =  WAIT;
	}
}

void Calculate_flowrate()
{
	if((HAL_GetTick() - flowStartTick) > 1000)
	{
		flow_rate = pulse_count * mL_per_count * 60 / 1000; /* Ltr/min */ // Calibrate here
		inst_water_flowed = cumulative_count * mL_per_count / 1000; /* in Ltr */
		pulse_count = 0;
		transmit_flag=1;
		flowStartTick = HAL_GetTick();
	}
}

void UART_transmit(float var1, float var2)
{
	if(transmit_flag)
	{
		printf("%05.2f", var1);
		printf("%05.2f\r\n", (float)(var2)/100.0);
		transmit_flag=0;
	}
}

//void Read_FRAM(uint8_t data)
//{
//if( HAL_I2C_Mem_Read(&hi2c1, FRAM_ADDRESS , FLOW_ADDRESS, I2C_MEMADD_SIZE_16BIT,(uint8_t *) &data, sizeof(data), 100) != HAL_OK)
//	{
//		printf("Read Failure/r/n");
//	}
//
//	//ReadErr = HAL_I2C_Mem_Read(&hi2c1, FRAM_ADDRESS , FLOW_ADDRESS, I2C_MEMADD_SIZE_16BIT,(uint8_t *) &data, sizeof(data), 100);
//}


//void Write_FRAM(uint8_t data)
//{
//
//	if(HAL_I2C_Mem_Write(&hi2c1, FRAM_ADDRESS , FLOW_ADDRESS, I2C_MEMADD_SIZE_16BIT,(uint8_t *)  &data, sizeof(data), 100) != HAL_OK)
//	{
//		printf("Write Failure/r/n");
//	}
//
//}

uint32_t Read_from_FRAM()
{
	HAL_I2C_Mem_Read(&hi2c1, FRAM_ADDRESS , FLOW_ADDRESS, I2C_MEMADD_SIZE_16BIT,(uint8_t *) &total_water_flowed, sizeof(total_water_flowed), 100);
    return total_water_flowed;
}





void Reset_FRAM()
{
    uint32_t data = 0x0000;
    HAL_I2C_Mem_Write(&hi2c1, FRAM_ADDRESS , FLOW_ADDRESS, I2C_MEMADD_SIZE_16BIT,(uint8_t *)  &data, sizeof(data), 100);
    Delay_ms(1);
    memory_reset_flag = 0;
    total_water_flowed = 0;
    flow_state = WAIT;
}


   /* uint8_t reset_data[32]; // Array to hold the reset data
    memset(reset_data, 0x00, sizeof(reset_data)); // Fill the array with 0xFF (reset value)

    // Write the reset data to the FRAM using burst write mode
    HAL_I2C_Mem_Write(&hi2c1, FRAM_ADDRESS, FLOW_ADDRESS, I2C_MEMADD_SIZE_16BIT, reset_data, sizeof(reset_data), 100);

    // Reset the necessary variables
    memory_reset_flag = 0;
    total_water_flowed = 0;
    flow_state = WAIT;

}*/
